OGRE: Ogre::VulkanRenderSystem Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::VulkanRenderSystem Class Reference
RenderSystems » Vulkan

`#include <OgreVulkanRenderSystem.h>`

Inheritance diagram for Ogre::VulkanRenderSystem:
[legend]

## Public Member Functions
| VulkanRenderSystem ()
| ~VulkanRenderSystem ()
void | _beginFrame (void) override
| Signifies the beginning of a frame, i.e.
void | _convertProjectionMatrix (const Matrix4 &matrix, Matrix4 &dest, bool) override
| Converts a uniform projection matrix to suitable for this render system.
DepthBuffer * | _createDepthBufferFor (RenderTarget *renderTarget) override
| Creates a DepthBuffer that can be attached to the specified RenderTarget.
RenderWindow * | _createRenderWindow (const String &name, uint32 width, uint32 height, bool fullScreen, const NameValuePairList *miscParams=0) override
void | _endFrame (void) override
| Ends rendering of a frame to the current viewport.
virtual VulkanFrameBufferDescMap & | _getFrameBufferDescMap (void)
void | _notifyActiveComputeEnded (void)
void | _notifyActiveEncoderEnded ()
void | _notifyDeviceStalled ()
void | _render (const RenderOperation &op) override
| Render something to the active viewport.
void | _setAlphaRejectSettings (CompareFunction func, unsigned char value, bool alphaToCoverage) override
| Sets the global alpha rejection approach for future renders.
void | _setCullingMode (CullingMode mode) override
| Sets the culling mode for the render system based on the 'vertex winding'.
void | _setDepthBias (float constantBias, float slopeScaleBias=0.0f) override
| Sets the depth bias, NB you should use the Material version of this.
void | _setDepthBufferParams (bool depthTest, bool depthWrite, CompareFunction depthFunction) override
| Sets the mode of operation for depth buffer tests from this point onwards.
void | _setDepthClamp (bool enable) override
| Clamp depth values to near and far plane rather than discarding.
void | _setPolygonMode (PolygonMode level) override
| Sets how to rasterise triangles, as points, wireframe or solid polys.
void | _setRenderTarget (RenderTarget *target) override
| Set current render target to target, enabling its device context if needed.
void | _setSampler (size_t texUnit, Sampler &s) override
| set the sampler settings for the given texture unit
void | _setTexture (size_t unit, bool enabled, const TexturePtr &texPtr) override
| Sets the texture to bind to a given texture unit.
void | _setViewport (Viewport *vp) override
| Sets the provided viewport as the active one for future rendering operations.
virtual void | beginGPUSampleProfile (const String &name, uint32 *hashCache)
void | beginProfileEvent (const String &eventName) override
| This marks the beginning of an event for GPU profiling.
void | bindGpuProgram (GpuProgram *prg) override
| Binds a given GpuProgram (but not the parameters).
void | bindGpuProgramParameters (GpuProgramType gptype, const GpuProgramParametersPtr &params, uint16 variabilityMask) override
| Bind Gpu program parameters.
void | clearFrameBuffer (unsigned int buffers, const ColourValue &colour=ColourValue::Black, float depth=1.0f, unsigned short stencil=0) override
HardwareOcclusionQuery * | createHardwareOcclusionQuery (void) override
| Create an object for performing hardware occlusion queries.
MultiRenderTarget * | createMultiRenderTarget (const String &name) override
| Create a MultiRenderTarget, which is a render target that renders to multiple RenderTextures at once.
RenderSystemCapabilities * | createRenderSystemCapabilities (void) const override
| Query the real capabilities of the GPU and driver in the RenderSystem.
virtual void | deinitGPUProfiling (void)
virtual void | endGPUSampleProfile (const String &name)
void | endProfileEvent (void) override
| Ends the currently active GPU profiling event.
void | endRenderPassDescriptor ()
void | executeRenderPassDescriptorDelayedActions (bool officialCall=true)
void | flushUAVs (void)
Real | getHorizontalTexelOffset (void) override
| Returns the horizontal texel offset value required for mapping texel origins to pixel origins in this rendersystem.
Real | getMaximumDepthInputValue (void) override
| Gets the maximum (farthest) depth value to be used when rendering using identity transforms.
Real | getMinimumDepthInputValue (void) override
| Gets the minimum (closest) depth value to be used when rendering using identity transforms.
const String & | getName (void) const override
| Returns the name of the rendering system.
Real | getVerticalTexelOffset (void) override
| Returns the vertical texel offset value required for mapping texel origins to pixel origins in this rendersystem.
VkInstance | getVkInstance (void) const
VulkanDevice * | getVulkanDevice () const
void | initConfigOptions () override
virtual void | initGPUProfiling (void)
void | markProfileEvent (const String &event) override
| Marks an instantaneous event for graphics profilers.
void | notifySwapchainDestroyed ()
void | refreshConfig ()
void | resetAllBindings (void)
void | setColourBlendState (const ColourBlendState &state) override
| Sets the global blending factors for combining subsequent renders with the existing frame contents.
void | setConfigOption (const String &name, const String &value) override
| Sets an option for this API.
void | setScissorTest (bool enabled, const Rect &rect=Rect()) override
| Sets the 'scissor region' i.e.
void | setStencilState (const StencilState &state) override
| This method allows you to set all the stencil buffer parameters in one call.
void | shutdown (void) override
| Shutdown the renderer and cleanup resources.
Public Member Functions inherited from Ogre::RenderSystem
| RenderSystem ()
| Default Constructor.
virtual | ~RenderSystem ()
| Destructor.
void | _beginGeometryCount (void)
| The RenderSystem will keep a count of tris rendered, this resets the count.
void | _cleanupDepthBuffers (bool bCleanManualBuffers=true)
| Removes all depth buffers.
virtual RenderWindow * | _createRenderWindow (const String &name, unsigned int width, unsigned int height, bool fullScreen, const NameValuePairList *miscParams=0)
| Creates a new rendering window.
virtual void | _disableTextureUnit (size_t texUnit)
| Turns off a texture unit.
virtual void | _disableTextureUnitsFrom (size_t texUnit)
| Disables all texture units from the given unit upwards.
virtual void | _dispatchCompute (const Vector3i &workgroupDim)
unsigned int | _getBatchCount (void) const
| Reports the number of batches rendered since the last _beginGeometryCount call.
virtual CullingMode | _getCullingMode (void) const
const String & | _getDefaultViewportMaterialScheme (void) const
| Returns the default material scheme used by the render system.
unsigned int | _getFaceCount (void) const
| Reports the number of tris rendered since the last _beginGeometryCount call.
unsigned int | _getVertexCount (void) const
| Reports the number of vertices passed to the renderer since the last _beginGeometryCount call.
virtual Viewport * | _getViewport (void)
| Get the current active viewport for rendering.
virtual void | _initialise ()
| Start up the renderer using the settings selected (Or the defaults if none have been selected).
void | _initRenderTargets (void)
| Utility method for initialising all render targets attached to this rendering system.
void | _notifyCameraRemoved (const Camera *cam)
| Utility method to notify all render targets that a camera has been removed, in case they were referring to it as their viewer.
void | _setColourBufferWriteEnabled (bool red, bool green, bool blue, bool alpha)
void | _setFog (FogMode f)
virtual void | _setLineWidth (float width)
| Set the line width when drawing as RenderOperation::OT_LINE_LIST/ RenderOperation::OT_LINE_STRIP.
virtual void | _setPointParameters (bool attenuationEnabled, Real minSize, Real maxSize)
virtual void | _setPointSpritesEnabled (bool enabled)
| Sets whether or not rendering points using OT_POINT_LIST will render point sprites (textured quads) or plain points.
void | _setProjectionMatrix (Matrix4 m)
void | _setSceneBlending (SceneBlendFactor sourceFactor, SceneBlendFactor destFactor, SceneBlendOperation op=SBO_ADD)
void | _setSeparateSceneBlending (SceneBlendFactor sourceFactor, SceneBlendFactor destFactor, SceneBlendFactor sourceFactorAlpha, SceneBlendFactor destFactorAlpha, SceneBlendOperation op=SBO_ADD, SceneBlendOperation alphaOp=SBO_ADD)
virtual void | _setTextureBlendMode (size_t unit, const LayerBlendModeEx &bm)
| Sets the texture blend modes from a TextureUnitState record.
virtual void | _setTextureCoordCalculation (size_t unit, TexCoordCalcMethod m, const Frustum *frustum=0)
| Sets a method for automatically calculating texture coordinates for a stage.
virtual void | _setTextureCoordSet (size_t unit, size_t index)
| Sets the texture coordinate set to use for a texture unit.
virtual void | _setTextureMatrix (size_t unit, const Matrix4 &xform)
| Sets the texture coordinate transformation matrix for a texture unit.
virtual void | _setTextureProjectionRelativeTo (bool enabled, const Vector3 &pos)
| Notify the rendersystem that it should adjust texture projection to be relative to a different origin.
virtual void | _setTextureUnitSettings (size_t texUnit, TextureUnitState &tl)
| Utility function for setting all the properties of a texture unit at once.
void | _setViewMatrix (const Matrix4 &m)
void | _setWorldMatrix (const Matrix4 &m)
virtual void | _swapAllRenderTargetBuffers ()
| Internal method for swapping all the buffers on all render targets, if _updateAllRenderTargets was called with a 'false' parameter.
virtual void | _updateAllRenderTargets (bool swapBuffers=true)
| Internal method for updating all render targets attached to this rendering system.
virtual void | _useLights (unsigned short limit)
| Tells the rendersystem to use the attached set of lights (and no others) up to the number specified (this allows the same list to be used with different count limits).
void | addListener (Listener *l)
| Adds a listener to the custom events that this render system can raise.
virtual void | applyFixedFunctionParams (const GpuProgramParametersPtr &params, uint16 variabilityMask)
void | attachRenderTarget (RenderTarget &target)
| Attaches the passed render target to the render system.
virtual void | clearFrameBuffer (uint32 buffers, const ColourValue &colour=ColourValue::Black, float depth=1.0f, uint16 stencil=0)=0
| Clears one or more frame buffers on the active render target.
virtual void | destroyHardwareOcclusionQuery (HardwareOcclusionQuery *hq)
| Destroy a hardware occlusion query object.
virtual void | destroyRenderTarget (const String &name)
| Destroys a render target of any sort.
virtual void | destroyRenderTexture (const String &name)
| Destroys a render texture.
virtual void | destroyRenderWindow (const String &name)
| Destroys a render window.
virtual RenderTarget * | detachRenderTarget (const String &name)
| Detaches the render target with the passed name from the render system and returns a pointer to it.
void | disableSchemeInstancing (const String &materialScheme)
| disables instancing for the given material scheme
void | enableSchemeInstancing (const String &materialScheme, const HardwareVertexBufferPtr &buffer, VertexDeclaration *decl, uint32 instanceCount)
| Sets the global instance data for the given material scheme.
const RenderSystemCapabilities * | getCapabilities (void) const
| Gets the capabilities of the render system.
const ConfigOptionMap & | getConfigOptions () const
| Returns the details of this API's configuration options.
virtual void | getCustomAttribute (const String &name, void *pData)
| Gets a custom (maybe platform-specific) attribute.
const DriverVersion & | getDriverVersion (void) const
| Returns the driver version.
virtual const GpuProgramParametersPtr & | getFixedFunctionParams (TrackVertexColourType tracking, FogMode fog)
uint32 | getGlobalInstanceCount () const
HardwareVertexBufferPtr | getGlobalInstanceVertexBuffer () const
VertexDeclaration * | getGlobalInstanceVertexDeclaration () const
bool | getInvertVertexWinding (void) const
| Indicates whether or not the vertex windings set will be inverted for the current render (e.g.
RenderSystemCapabilities * | getMutableCapabilities ()
| Get a pointer to the current capabilities being used by the RenderSystem.
uint16 | getNativeShadingLanguageVersion () const
| Gets the native shading language version for this render system.
const StringVector & | getRenderSystemEvents (void) const
| Gets a list of the rendersystem specific events that this rendersystem can raise.
RenderTarget * | getRenderTarget (const String &name)
| Returns a pointer to the render target with the passed name, or NULL if that render target cannot be found.
RenderWindowDescription | getRenderWindowDescription () const
| get a RenderWindowDescription from the current ConfigOptionMap
GlobalInstancingData | getSchemeInstancingData (const String &materialScheme) const
| Gets all data for the global scheme based instancing.
bool | isGpuProgramBound (GpuProgramType gptype)
| Returns whether or not a Gpu program of the given type is currently bound.
bool | isReverseDepthBufferEnabled () const
| Returns if reverse Z-buffer is enabled.
virtual void | postExtraThreadsStarted ()
| Tell the rendersystem to perform any tasks it needs to directly after other threads which might access the rendering API are registered.
virtual void | preExtraThreadsStarted ()
| Tell the rendersystem to perform any prep tasks it needs to directly before other threads which might access the rendering API are registered.
virtual void | registerThread ()
| Register the an additional thread which may make calls to rendersystem-related objects.
void | reinitialise (void)
| Restart the renderer (normally following a change in settings).
void | removeListener (Listener *l)
| Remove a listener to the custom events that this render system can raise.
virtual void | setClipPlanes (const PlaneList &clipPlanes)
| Sets the user clipping region.
virtual void | setCurrentPassIterationCount (const size_t count)
| set the current multi pass count value.
void | setDepthBufferFor (RenderTarget *renderTarget)
| Retrieves an existing DepthBuffer or creates a new one suited for the given RenderTarget and sets it.
void | setDeriveDepthBias (bool derive, float baseValue=0.0f, float multiplier=0.0f, float slopeScale=0.0f)
| Tell the render system whether to derive a depth bias on its own based on the values passed to it in setCurrentPassIterationCount.
virtual bool | setDrawBuffer (ColourBufferType colourBuffer)
| Sets the colour buffer that the render system will to draw.
void | setGlobalInstanceCount (uint32 val)
void | setGlobalInstanceVertexBuffer (const HardwareVertexBufferPtr &val)
void | setGlobalInstanceVertexDeclaration (VertexDeclaration *val)
void | setInvertVertexWinding (bool invert)
| Sets whether or not vertex windings set should be inverted; this can be important for rendering reflections.
virtual void | setLightingEnabled (bool enabled)
| Sets whether or not dynamic lighting is enabled.
virtual void | setNormaliseNormals (bool normalise)
| Sets whether or not normals are to be automatically normalised.
void | setScissorTest (bool enabled, uint32 left, uint32 top=0, uint32 right=800, uint32 bottom=600)
virtual void | setShadingType (ShadeOptions so)
| Sets the type of light shading required (default = Gouraud).
void | setStencilBufferParams (CompareFunction func=CMPF_ALWAYS_PASS, uint32 refValue=0, uint32 compareMask=0xFFFFFFFF, uint32 writeMask=0xFFFFFFFF, StencilOperation stencilFailOp=SOP_KEEP, StencilOperation depthFailOp=SOP_KEEP, StencilOperation passOp=SOP_KEEP, bool twoSidedOperation=false)
void | setStencilCheckEnabled (bool enabled)
virtual void | unbindGpuProgram (GpuProgramType gptype)
| Unbinds GpuPrograms of a given GpuProgramType.
virtual void | unregisterThread ()
| Unregister an additional thread which may make calls to rendersystem-related objects.
void | useCustomRenderSystemCapabilities (RenderSystemCapabilities *capabilities)
| Force the render system to use the special capabilities.
virtual String | validateConfigOptions (void)
| Validates the options set for the rendering system, returning a message if there are problems.

## Additional Inherited Members
Static Public Member Functions inherited from Ogre::RenderSystem
static void | convertColourValue (const ColourValue &colour, uint32 *pDest)
static VertexElementType | getColourVertexElementType (void)
static Listener * | getSharedListener (void)
| Retrieve a pointer to the current shared render system listener.
static void | setSharedListener (Listener *listener)
| Sets shared listener.

## Constructor & Destructor Documentation

## ◆ VulkanRenderSystem()

Ogre::VulkanRenderSystem::VulkanRenderSystem | ( |  | ) |

## ◆ ~VulkanRenderSystem()

Ogre::VulkanRenderSystem::~VulkanRenderSystem | ( |  | ) |

## Member Function Documentation

## ◆ shutdown()

void Ogre::VulkanRenderSystem::shutdown | ( | void |  | ) |
| overridevirtual

Shutdown the renderer and cleanup resources.

Reimplemented from Ogre::RenderSystem.

## ◆ getName()

const String & Ogre::VulkanRenderSystem::getName | ( | void |  | ) | const
| overridevirtual

Returns the name of the rendering system.

Implements Ogre::RenderSystem.

## ◆ refreshConfig()

void Ogre::VulkanRenderSystem::refreshConfig | ( |  | ) |

## ◆ initConfigOptions()

void Ogre::VulkanRenderSystem::initConfigOptions | ( |  | ) |
| overridevirtual

Reimplemented from Ogre::RenderSystem.

## ◆ setConfigOption()

void Ogre::VulkanRenderSystem::setConfigOption | ( | const String & | name,
|  | const String & | value )
| overridevirtual

Sets an option for this API.

Used to confirm the settings (normally chosen by the user) in order to make the renderer able to initialise with the settings as required. This may initialise the RenderWindowDescription or set some RenderSystem specific parameters. Called automatically by the default configuration dialog, and by the restoration of saved settings. These settings are stored and only activated when RenderSystem::_initialise or RenderSystem::reinitialise are called.

If using a custom configuration dialog, it is advised that the caller calls RenderSystem::getConfigOptions again, since some options can alter resulting from a selection.

Common options:

Key | Default | Description
--- | --- | ---
Full Screen | false | Window full-screen flag
VSync | true | "vsync" in _createRenderWindow
VSync Interval | 1 | "vsyncInterval" in _createRenderWindow
sRGB Gamma Conversion | false | "gamma" in _createRenderWindow
FSAA | 0 | concatenation of "FSAA" and "FSAAHint" as in _createRenderWindow
Video Mode | - | Window resolution
Display Frequency | - | "displayFrequency" in _createRenderWindow
Content Scaling Factor | 1.0 | "contentScalingFactor" in _createRenderWindow

Parameters

  name | The name of the option to alter.
  value | The value to set the option to.

Implements Ogre::RenderSystem.

## ◆ createHardwareOcclusionQuery()

HardwareOcclusionQuery * Ogre::VulkanRenderSystem::createHardwareOcclusionQuery | ( | void |  | ) |
| overridevirtual

Create an object for performing hardware occlusion queries.

Implements Ogre::RenderSystem.

## ◆ createRenderSystemCapabilities()

RenderSystemCapabilities * Ogre::VulkanRenderSystem::createRenderSystemCapabilities | ( | void |  | ) | const
| overridevirtual

Query the real capabilities of the GPU and driver in the RenderSystem.

Implements Ogre::RenderSystem.

## ◆ resetAllBindings()

void Ogre::VulkanRenderSystem::resetAllBindings | ( | void |  | ) |

## ◆ getVkInstance()

VkInstance Ogre::VulkanRenderSystem::getVkInstance | ( | void |  | ) | const
| inline

## ◆ _createRenderWindow()

RenderWindow * Ogre::VulkanRenderSystem::_createRenderWindow | ( | const String & | name,
|  | uint32 | width,
|  | uint32 | height,
|  | bool | fullScreen,
|  | const NameValuePairList * | miscParams = 0 )
| override

## ◆ flushUAVs()

void Ogre::VulkanRenderSystem::flushUAVs | ( | void |  | ) |

## ◆ _setTexture()

void Ogre::VulkanRenderSystem::_setTexture | ( | size_t | unit,
|  | bool | enabled,
|  | const TexturePtr & | texPtr )
| overridevirtual

Sets the texture to bind to a given texture unit.

User processes would not normally call this direct unless rendering primitives themselves.

Parameters

  unit | The index of the texture unit to modify. Multitexturing hardware can support multiple units (see RenderSystemCapabilites::getNumTextureUnits)
  enabled | Boolean to turn the unit on/off
  texPtr | Pointer to the texture to use.

Implements Ogre::RenderSystem.

## ◆ _getFrameBufferDescMap()

virtual VulkanFrameBufferDescMap & Ogre::VulkanRenderSystem::_getFrameBufferDescMap | ( | void |  | ) |
| inlinevirtual

## ◆ _beginFrame()

void Ogre::VulkanRenderSystem::_beginFrame | ( | void |  | ) |
| overridevirtual

Signifies the beginning of a frame, i.e.

the start of rendering on a single viewport. Will occur several times per complete frame if multiple viewports exist.

Reimplemented from Ogre::RenderSystem.

## ◆ _endFrame()

void Ogre::VulkanRenderSystem::_endFrame | ( | void |  | ) |
| overridevirtual

Ends rendering of a frame to the current viewport.

Implements Ogre::RenderSystem.

## ◆ _render()

void Ogre::VulkanRenderSystem::_render | ( | const RenderOperation & | op | ) |
| overridevirtual

Render something to the active viewport.

Low-level rendering interface to perform rendering operations. Unlikely to be used directly by client applications, since the SceneManager and various support classes will be responsible for calling this method. Can only be called between _beginScene and _endScene

Parameters

  op | A rendering operation instance, which contains details of the operation to be performed.

Reimplemented from Ogre::RenderSystem.

## ◆ bindGpuProgram()

void Ogre::VulkanRenderSystem::bindGpuProgram | ( | GpuProgram * | prg | ) |
| overridevirtual

Binds a given GpuProgram (but not the parameters).

Remarks
  Only one GpuProgram of each type can be bound at once, binding another one will simply replace the existing one.

Reimplemented from Ogre::RenderSystem.

## ◆ bindGpuProgramParameters()

void Ogre::VulkanRenderSystem::bindGpuProgramParameters | ( | GpuProgramType | gptype,
|  | const GpuProgramParametersPtr & | params,
|  | uint16 | variabilityMask )
| overridevirtual

Bind Gpu program parameters.

Parameters

  gptype | The type of program to bind the parameters to
  params | The parameters to bind
  variabilityMask | A mask of GpuParamVariability identifying which params need binding

Implements Ogre::RenderSystem.

## ◆ getHorizontalTexelOffset()

Real Ogre::VulkanRenderSystem::getHorizontalTexelOffset | ( | void |  | ) |
| overridevirtual

Returns the horizontal texel offset value required for mapping texel origins to pixel origins in this rendersystem.

Since rendersystems sometimes disagree on the origin of a texel, mapping from texels to pixels can sometimes be problematic to implement generically. This method allows you to retrieve the offset required to map the origin of a texel to the origin of a pixel in the horizontal direction.

Note
  only non-zero with D3D9

Reimplemented from Ogre::RenderSystem.

## ◆ getVerticalTexelOffset()

Real Ogre::VulkanRenderSystem::getVerticalTexelOffset | ( | void |  | ) |
| overridevirtual

Returns the vertical texel offset value required for mapping texel origins to pixel origins in this rendersystem.

Since rendersystems sometimes disagree on the origin of a texel, mapping from texels to pixels can sometimes be problematic to implement generically. This method allows you to retrieve the offset required to map the origin of a texel to the origin of a pixel in the vertical direction.

Note
  only non-zero with D3D9

Reimplemented from Ogre::RenderSystem.

## ◆ getMinimumDepthInputValue()

Real Ogre::VulkanRenderSystem::getMinimumDepthInputValue | ( | void |  | ) |
| overridevirtual

Gets the minimum (closest) depth value to be used when rendering using identity transforms.

When using identity transforms you can manually set the depth of a vertex; however the input values required differ per rendersystem. This method lets you retrieve the correct value.

See also
  Renderable::getUseIdentityView, Renderable::getUseIdentityProjection

Implements Ogre::RenderSystem.

## ◆ getMaximumDepthInputValue()

Real Ogre::VulkanRenderSystem::getMaximumDepthInputValue | ( | void |  | ) |
| overridevirtual

Gets the maximum (farthest) depth value to be used when rendering using identity transforms.

When using identity transforms you can manually set the depth of a vertex; however the input values required differ per rendersystem. This method lets you retrieve the correct value.

See also
  Renderable::getUseIdentityView, Renderable::getUseIdentityProjection

Implements Ogre::RenderSystem.

## ◆ beginProfileEvent()

void Ogre::VulkanRenderSystem::beginProfileEvent | ( | const String & | eventName | ) |
| overridevirtual

This marks the beginning of an event for GPU profiling.

Implements Ogre::RenderSystem.

## ◆ endProfileEvent()

void Ogre::VulkanRenderSystem::endProfileEvent | ( | void |  | ) |
| overridevirtual

Ends the currently active GPU profiling event.

Implements Ogre::RenderSystem.

## ◆ markProfileEvent()

void Ogre::VulkanRenderSystem::markProfileEvent | ( | const String & | event | ) |
| overridevirtual

Marks an instantaneous event for graphics profilers.

This is equivalent to calling

See also
  beginProfileEvent and
  endProfileEvent back to back.

Implements Ogre::RenderSystem.

## ◆ initGPUProfiling()

virtual void Ogre::VulkanRenderSystem::initGPUProfiling | ( | void |  | ) |
| virtual

## ◆ deinitGPUProfiling()

virtual void Ogre::VulkanRenderSystem::deinitGPUProfiling | ( | void |  | ) |
| virtual

## ◆ beginGPUSampleProfile()

virtual void Ogre::VulkanRenderSystem::beginGPUSampleProfile | ( | const String & | name,
|  | uint32 * | hashCache )
| virtual

## ◆ endGPUSampleProfile()

virtual void Ogre::VulkanRenderSystem::endGPUSampleProfile | ( | const String & | name | ) |
| virtual

## ◆ executeRenderPassDescriptorDelayedActions()

void Ogre::VulkanRenderSystem::executeRenderPassDescriptorDelayedActions | ( | bool | officialCall = true | ) |

## ◆ endRenderPassDescriptor()

void Ogre::VulkanRenderSystem::endRenderPassDescriptor | ( |  | ) |

## ◆ _createDepthBufferFor()

DepthBuffer * Ogre::VulkanRenderSystem::_createDepthBufferFor | ( | RenderTarget * | renderTarget | ) |
| overridevirtual

Creates a DepthBuffer that can be attached to the specified RenderTarget.

It doesn't attach anything, it just returns a pointer to a new DepthBuffer Caller is responsible for putting this buffer into the right pool, for attaching, and deleting it. Here's where API-specific magic happens. Don't call this directly unless you know what you're doing.

Implements Ogre::RenderSystem.

## ◆ notifySwapchainDestroyed()

void Ogre::VulkanRenderSystem::notifySwapchainDestroyed | ( |  | ) |

## ◆ getVulkanDevice()

VulkanDevice * Ogre::VulkanRenderSystem::getVulkanDevice | ( |  | ) | const
| inline

## ◆ _notifyDeviceStalled()

void Ogre::VulkanRenderSystem::_notifyDeviceStalled | ( |  | ) |

## ◆ _notifyActiveEncoderEnded()

void Ogre::VulkanRenderSystem::_notifyActiveEncoderEnded | ( |  | ) |

## ◆ _notifyActiveComputeEnded()

void Ogre::VulkanRenderSystem::_notifyActiveComputeEnded | ( | void |  | ) |

## ◆ _setViewport()

void Ogre::VulkanRenderSystem::_setViewport | ( | Viewport * | vp | ) |
| overridevirtual

Sets the provided viewport as the active one for future rendering operations.

This viewport is aware of it's own camera and render target. Must be implemented by subclass.

Parameters

  vp | Pointer to the appropriate viewport.

Implements Ogre::RenderSystem.

## ◆ _setRenderTarget()

void Ogre::VulkanRenderSystem::_setRenderTarget | ( | RenderTarget * | target | ) |
| overridevirtual

Set current render target to target, enabling its device context if needed.

Implements Ogre::RenderSystem.

## ◆ clearFrameBuffer()

void Ogre::VulkanRenderSystem::clearFrameBuffer | ( | unsigned int | buffers,
|  | const ColourValue & | colour = ColourValue::Black,
|  | float | depth = 1.0f,
|  | unsigned short | stencil = 0 )
| override

References Ogre::ColourValue::Black.

## ◆ setScissorTest()

void Ogre::VulkanRenderSystem::setScissorTest | ( | bool | enabled,
|  | const Rect & | rect = Rect() )
| overridevirtual

Sets the 'scissor region' i.e.

the region of the target in which rendering can take place.

This method allows you to 'mask off' rendering in all but a given rectangular area as identified by the parameters to this method.

Parameters

  enabled | True to enable the scissor test, false to disable it.
  rect | The location of the corners of the rectangle, expressed in pixels.

Implements Ogre::RenderSystem.

## ◆ setStencilState()

void Ogre::VulkanRenderSystem::setStencilState | ( | const StencilState & | state | ) |
| overridevirtual

This method allows you to set all the stencil buffer parameters in one call.

Unlike other render states, stencilling is left for the application to turn on and off when it requires. This is because you are likely to want to change parameters between batches of arbitrary objects and control the ordering yourself. In order to batch things this way, you'll want to use OGRE's Compositor stencil pass or separate render queue groups and register a RenderQueueListener to get notifications between batches.

See also
  RenderQueue

Implements Ogre::RenderSystem.

## ◆ _setPolygonMode()

void Ogre::VulkanRenderSystem::_setPolygonMode | ( | PolygonMode | level | ) |
| overridevirtual

Sets how to rasterise triangles, as points, wireframe or solid polys.

Implements Ogre::RenderSystem.

## ◆ _convertProjectionMatrix()

void Ogre::VulkanRenderSystem::_convertProjectionMatrix | ( | const Matrix4 & | matrix,
|  | Matrix4 & | dest,
|  | bool | forGpuProgram )
| overridevirtual

Converts a uniform projection matrix to suitable for this render system.

Because different APIs have different requirements (some incompatible) for the projection matrix, this method allows each to implement their own correctly and pass back a generic OGRE matrix for storage in the engine.

Implements Ogre::RenderSystem.

## ◆ _setDepthBias()

void Ogre::VulkanRenderSystem::_setDepthBias | ( | float | constantBias,
|  | float | slopeScaleBias = 0.0f )
| overridevirtual

Sets the depth bias, NB you should use the Material version of this.

When polygons are coplanar, you can get problems with 'depth fighting' where the pixels from the two polys compete for the same screen pixel. This is particularly a problem for decals (polys attached to another surface to represent details such as bulletholes etc.).

  A way to combat this problem is to use a depth bias to adjust the depth buffer value used for the decal such that it is slightly higher than the true value, ensuring that the decal appears on top.

Note
  The final bias value is a combination of a constant bias and a bias proportional to the maximum depth slope of the polygon being rendered. The final bias is constantBias + slopeScaleBias * maxslope. Slope scale biasing is generally preferable but is not available on older hardware.

Parameters

  constantBias | The constant bias value, expressed as a value in homogeneous depth coordinates.
  slopeScaleBias | The bias value which is factored by the maximum slope of the polygon, see the description above. This is not supported by all cards.

Implements Ogre::RenderSystem.

## ◆ _setDepthBufferParams()

void Ogre::VulkanRenderSystem::_setDepthBufferParams | ( | bool | depthTest,
|  | bool | depthWrite,
|  | CompareFunction | depthFunction )
| overridevirtual

Sets the mode of operation for depth buffer tests from this point onwards.

Sometimes you may wish to alter the behaviour of the depth buffer to achieve special effects. Because it's unlikely that you'll set these options for an entire frame, but rather use them to tweak settings between rendering objects, this is an internal method (indicated by the '_' prefix) which will be used by a SceneManager implementation rather than directly from the client application. If this method is never called the settings are automatically the same as the default parameters.

Parameters

  depthTest | If true, the depth buffer is tested for each pixel and the frame buffer is only updated if the depth function test succeeds. If false, no test is performed and pixels are always written.
  depthWrite | If true, the depth buffer is updated with the depth of the new pixel if the depth test succeeds. If false, the depth buffer is left unchanged even if a new pixel is written.
  depthFunction | Sets the function required for the depth test.

Implements Ogre::RenderSystem.

## ◆ _setDepthClamp()

void Ogre::VulkanRenderSystem::_setDepthClamp | ( | bool | enable | ) |
| overridevirtual

Clamp depth values to near and far plane rather than discarding.

Useful for "shadow caster pancaking" or with shadow volumes

Reimplemented from Ogre::RenderSystem.

## ◆ _setCullingMode()

void Ogre::VulkanRenderSystem::_setCullingMode | ( | CullingMode | mode | ) |
| overridevirtual

Sets the culling mode for the render system based on the 'vertex winding'.

A typical way for the rendering engine to cull triangles is based on the 'vertex winding' of triangles. Vertex winding refers to the direction in which the vertices are passed or indexed to in the rendering operation as viewed from the camera, and will either be clockwise or anticlockwise (that's 'counterclockwise' for you Americans out there ;) The default is Ogre::CULL_CLOCKWISE i.e. that only triangles whose vertices are passed/indexed in anticlockwise order are rendered - this is a common approach and is used in 3D studio models for example. You can alter this culling mode if you wish but it is not advised unless you know what you are doing.

You may wish to use the Ogre::CULL_NONE option for mesh data that you cull yourself where the vertex winding is uncertain or for creating 2-sided passes.

Implements Ogre::RenderSystem.

## ◆ _setAlphaRejectSettings()

void Ogre::VulkanRenderSystem::_setAlphaRejectSettings | ( | CompareFunction | func,
|  | unsigned char | value,
|  | bool | alphaToCoverage )
| overridevirtual

Sets the global alpha rejection approach for future renders.

By default images are rendered regardless of texture alpha. This method lets you change that.

Parameters

  func | The comparison function which must pass for a pixel to be written.
  value | The value to compare each pixels alpha value to (0-255)
  alphaToCoverage | Whether to enable alpha to coverage, if supported

Implements Ogre::RenderSystem.

## ◆ setColourBlendState()

void Ogre::VulkanRenderSystem::setColourBlendState | ( | const ColourBlendState & | state | ) |
| overridevirtual

Sets the global blending factors for combining subsequent renders with the existing frame contents.

Implements Ogre::RenderSystem.

## ◆ _setSampler()

void Ogre::VulkanRenderSystem::_setSampler | ( | size_t | texUnit,
|  | Sampler & | s )
| overridevirtual

set the sampler settings for the given texture unit

Implements Ogre::RenderSystem.

## ◆ createMultiRenderTarget()

MultiRenderTarget * Ogre::VulkanRenderSystem::createMultiRenderTarget | ( | const String & | name | ) |
| inlineoverridevirtual

Create a MultiRenderTarget, which is a render target that renders to multiple RenderTextures at once.

Surfaces can be bound and unbound at will. This fails if mCapabilities->getNumMultiRenderTargets() is smaller than 2.

Implements Ogre::RenderSystem.

The documentation for this class was generated from the following file:

- OgreVulkanRenderSystem.h